// Multiple Lagged Fibonacci RNGs
// See Knuth, The Art of Computer Programming, v. 2, p. 26ff
#ifndef LFRNG_H
#define LFRNG_H

namespace LFRNG {

class rng {
    unsigned k, l;
    unsigned imk, iml;
    unsigned *hstr;

    const static unsigned l_k = 98;
    const static unsigned l_l = 27;
    const static unsigned m_k = 73;
    const static unsigned m_l = 31;
    const static unsigned s_k = 55;
    const static unsigned s_l = 24;

public:
    rng(unsigned n);
    ~rng();
    void init();
    unsigned draw();
};

} //namespace LFRNG

#endif
