#include <iostream>
#include <cmath>

#include "frng.h"
#include "fparrng.h"

using namespace std;
using namespace FPRNG;

void test_fr(frng *g) {
	double avg = 0.0;
	double avg2 = 0.0;
	
  // Windows rand() produces only 16 bit integers
  // 10^5 draws should cause all 32 bits to be filled up
	for(int i = 0; i< 100000; ++i)
	    (*g)();
	
	for (int i = 0; i< 1000; ++i) {
	    double r = (*g)();
	    avg += r;
	    avg2 += r*r;
	}
	
	avg /= 1000;
	avg2 /= 1000;
	    
	cout << "Average: " << avg << "  Deviation: " << sqrt(avg2-avg*avg) << endl;
}

int main() {
	ftrianglerng triangle;
	fparrng parabolic;
	
	test_fr(&triangle);
	test_fr(&parabolic);
	
	return 0;
}
