#include <iostream>
#include <iomanip>
#include "atom.h"

using namespace std;

std::ostream& operator<< (std::ostream& s, const Atom& a) {
  ios_base::fmtflags savefmt = s.flags();
  s << left << setw(4) << a.symbol << right << scientific << setprecision(19) 
           << a.x << " " << a.y << " " << a.z;
  s.flags(savefmt);

  return s;
}

std::istream& operator>> (std::istream& s, Atom& a) {
  Atom temp;
  s >> temp.symbol >> temp.x  >> temp.y  >> temp.z;
  if (s) {
    a = temp;
  }

  return s;
}
