#include <fstream>  // For file handling 
#include <iomanip>  // For other I/O manipulators
#include <iostream>
#include <cstdlib>  // To get exit function
#include "lfrng.h"

using namespace std;
using namespace LFRNG;

int main() {

  nofirst small(30);
  rng *dynFRNG = new rng(56);
  coin penny;

  ofstream rng_out("rng_state.dat");
  if ( rng_out.fail() ) {
      cerr << "Cannot open file to save RNGs state" << endl;
      exit(EXIT_FAILURE);
  }

  cout << "Writing out states for different RNG classes" << endl;
  rng_out << small << endl;
  rng_out << *dynFRNG << endl;
  rng_out << penny << endl;
  if ( rng_out.fail() ) {
      cerr << "Something went wrong while saving RNGs state" << endl;
      exit(EXIT_FAILURE);
  }
  rng_out.close();

  cout << "nofirst draw: " << small()
      <<  ", rng draw: " << (*dynFRNG)()
      << ", coin toss: " << penny() << endl;
  
  ifstream rng_in("rng_state.dat");
  if ( rng_in.fail() ) {
      cerr << "Cannot open file to read RNGs state" << endl;
      exit(EXIT_FAILURE);
  }

  cout << "Reading saved states for different RNG classes" << endl;
  rng_in >> small;
  rng_in >> *dynFRNG;
  rng_in >> penny;
  if ( rng_in.fail() ) {
      cerr << "Something went wrong while reading RNGs state" << endl;
      exit(EXIT_FAILURE);
  }
  rng_in.close();

  cout << "nofirst draw: " << small()
      <<  ", rng draw: " << (*dynFRNG)()
      << ", coin toss: " << penny() << endl;

  return 0;
}
