#include <iostream>
#include <cstdlib>
#include <cmath>
#include "position.h"

using namespace std;

inline void printpos(position r) { // Helper function to print out positions
    cout << "( " << r.x << ", " << r.y << ", " << r.z << " )" << endl;
} 

int main() {
    position p, q;

    p = position(1.0, 2.0, -1.0); 
    q = position(-2.0, -1.0, 0.0);

    position r(p); // Default copy constructor 

// Just print out p and q
    cout << "p = ";
    printpos(p);

    cout << "q = ";
    printpos(q);

    cout << "distance = " << sqrt((p - q) * (p - q)) << endl;

    cout << "-p = ";
    printpos(-p);

    p *= 5.0;
    cout << "p *= 5.0 =" ;
    printpos(p);

    q += position(4.0, -1.0, 2.0);
    cout << "q += ";
    printpos(position(4.0, -1.0, 2.0));

    cout << "p = ";
    printpos(p);
    cout << "q =";
    printpos(q);

    cout << "0.2 * q + q 0.3 = ";
    printpos(0.2 * q + q * 0.3);

    cout << "p * q / 10.0 + 2 ="; // should give 0 if operator precedence is correct
    cout << p*q/10.0 +2 << endl;

//    q /= p; // compiler error: dividing by a position is not supported

//    if ( p > q ) // Another unsupported operator: compiler error! 
//        printpos(p);
//    else
//        printpos(q);

    if ( p == q )
        cout << "p and q are equal " << endl;
    else {
        cout << "p != q, p-q = ";
        printpos(p-q);
    }        

    return 0;
} 
