#include <iostream>
#include "position.h"

using namespace std;

inline void printpos(position r) { // Helper function to print out positions
    cout << "( " << r.x << ", " << r.y << ", " << r.z << " )" << endl;
}

struct velocity : public position {
    velocity() {}
    velocity(double a, double b, double c) : position(a,b,c) {}
};

int main() {
    position x(2, -1, 3), y;
    velocity v(0, 2, 0), w(1, 2, -1);

    cout << "v = ";
    printpos(v);
    cout << "w = ";
    printpos(w);

    cout << "Modulus of v is " << abs(v) << endl; 

    cout << "v + w = ";
    printpos( v + w );
   
    if ( v != w ) {
        cout << "v - w = ";
        printpos( v - w );
    }

    cout << "x = ";
    printpos(x);
    cout << "x * v = " << x * v << endl; 

//    v = x; // Compiler error: positions may not be assigned to velocities

    v += w;  // Works, as operator+= is a member
//    v = v-w;  // Compiler error: expression evaluates to a position!
//    v = v*2.0;  // Ditto!
    x = v; // Logical error: works!
    y = w;

    cout << "Result of a complicated expression involving positions: ";
    printpos( 3.0*x*5.0-y*(y*(x+x))/2 );    

    cout << "The same complicated expression involving velocities: ";
    printpos( 3.0*v*5.0-w*(w*(v+v))/2 );    
    return 0;
}
