#include <iostream>

#include "position.h"
#include "velocity.h"

using namespace std;

#define VECT_TYPE double
// #define VECT_TYPE float
// #define VECT_TYPE unsigned int

int main() {

    position<VECT_TYPE> x(2, -1, 3), y;
    position<float> z(x);
    velocity<VECT_TYPE> v(0, 2, 0), w(1, 2, -1);
    velocity<float> vv(w);

    cout << "x = " << x;
    cout << "y = " << y;
    cout << "z = " << z;

    cout << "v = " << v;
    cout << "w = " << w;
    cout << "vv = " << vv;

    // cout << "Modulus of v is " << abs(v) << endl; 
    cout << "x + y = " << (x+y);
    cout << "v + w = " << (v+w);
   
    if ( v != w ) {
        cout << "v - w = " << ( v-w);
    }

    v += w;  // Still works
    cout << "v += w " << v;
    cout << "w += z " << w;
    cout << "z -= w " << z;

//     cout << "x * v = " << x * v; // Compiler error: cannot convert position into velocity and viceversa
//     v = x; // Compiler error: positions may not be assigned to velocities

    // the following works only if VECT_TYPE == double otherwise explicit casts or conversions are needed
    // cout << "2.0 * v = " << 2.0 * v;
    // cout << "v * 2.0 = " << v * 2.0;
    cout << "2.0 * v = " << 2.0 * velocity<double>(v);
    cout << "v * 2.0 = " << velocity<double>(v) * 2.0;
    cout << "vv * 2.0F = " << vv * 2.0F;
    cout << "Result of a complicated expression involving positions in double: " << ( 3.0*x*5.0-y*(y*(x+x))/2 );    
    cout << "The same complicated expression involving velocities in double: " << ( 3.0*v*5.0-w*(w*(v+v))/2 );    

    return 0;
}

