#include <iostream>

#include "position.h"
#include "velocity.h"

using namespace std;

#define VECT_TYPE double
// #define VECT_TYPE float
// #define VECT_TYPE unsigned int

int main() {

    position<VECT_TYPE> x(2, -1, 3), y;
    velocity<VECT_TYPE> v(0, 2, 0), w(1, 2, -1);

    cout << "x = " << x;
    cout << "y = " << y;

    cout << "v = " << v;
    cout << "w = " << w;

    // cout << "Modulus of v is " << abs(v) << endl; 
    cout << "x + y = " << (x+y);
    cout << "v + w = " << (v+w);
   
    if ( v != w ) {
        cout << "v - w = " << ( v-w);
    }

    v += w;  // Still works
    cout << "v += w " << v;

//     cout << "x * v = " << x * v; // Compiler error: cannot convert position into velocity and viceversa
//     v = x; // Compiler error: positions may not be assigned to velocities

    // the following works only if VECT_TYPE == double
    // cout << "2.0 * v = " << 2.0 * v;
    // cout << "v * 2.0 = " << v * 2.0;
    // the following works only if VECT_TYPE == float
    cout << "2.0F * v = " << 2.0F * v;
    cout << "v * 2.0F = " << v * 2.0F;

    return 0;
}

