#include <iostream>
#include "pwlinear.h"

using namespace std;

int main() {
    double x[] = {0.0, 2.0, 4.0};
    double y[] = {-1.0, 7.0, -2.0};

    interpolator<double, pwconstant<double> > pconst(3, x, y);
    interpolator<double, pwlinear<double> > plin(3, x, y);
    interpolator<double, pwlinear_ext<double> > plinex(3, x, y);

    cout << "Constant interpolator: " << endl;
    cout << "x: " << pconst.x(0) << " " << pconst.x(1) << " " <<  pconst.x(2) << endl;
    cout << "y: " <<  pconst.y(0) << " " << pconst.y(1) << " " <<  pconst.y(2) << endl;
    
    pconst.setxy(1, 3.0, 6.0);
//    pconst.setxy(7, 3.0, 6.0); // throws exception: index is out of range!

    cout << "x: " << pconst.x(0) << " " << pconst.x(1) << " " << pconst.x(2) << endl;
    cout << "y: " << pconst.y(0) << " " << pconst.y(1) << " " << pconst.y(2) << endl;
    
    for(int i=0; i<11; ++i) {
       double x = i*0.4;
       cout << "table(" << x << ") = " << pconst(x) << endl;
    }

//    cout << pconst(19) << endl; // throws exception as x is out of range!   

    cout << "linear interpolator: " << endl;
    cout << "x: " << plin.x(0) << " " << plin.x(1) << " " <<  plin.x(2) << endl;
    cout << "y: " <<  plin.y(0) << " " << plin.y(1) << " " <<  plin.y(2) << endl;
    
    plin.setxy(1, 3.0, 6.0);

//    cout << plin(19) << endl; // throws exception as x is out of range!   
    cout << "x: " << plin.x(0) << " " << plin.x(1) << " " << plin.x(2) << endl;
    cout << "y: " << plin.y(0) << " " << plin.y(1) << " " << plin.y(2) << endl;
    
    for(int i=0; i<11; ++i) {
       double x = i*0.4;
       cout << "table(" << x << ") = " << plin(x) << endl;
    }
    
    cout << "linear interpolator with (insane) extrapolation: " << endl;
    cout << "x: " << plinex.x(0) << " " << plinex.x(1) << " " <<  plinex.x(2) << endl;
    cout << "y: " <<  plinex.y(0) << " " << plinex.y(1) << " " <<  plinex.y(2) << endl;
    
    plinex.setxy(1, 3.0, 6.0);

    cout << "x: " << plinex.x(0) << " " << plinex.x(1) << " " << plinex.x(2) << endl;
    cout << "y: " << plinex.y(0) << " " << plinex.y(1) << " " << plinex.y(2) << endl;
    
    for(int i=0; i<11; ++i) {
       double x = i*0.4;
       cout << "table(" << x << ") = " << plinex(x) << endl;
    }
    
    cout << "p(19) = " << plinex(19) << endl;

    return 0;
}
