#include <iostream>
#include "interpolator.h"

using namespace std;

int main() {
    double x[] = {4.0, 2.0, 0.0};
    double y[] = {-1.0, 7.0, -2.0};

    interpolator<double, pwconstant<double> > p(3, x, y);
    point<double>  t[] = { {0.0, 1.0}, {0.0, 2.0}, {2.0, 1.0} };
// Passing t to the constructor gives an exception for duplicated x values: 
//    interpolator<double, pwconstant<double> > q(3, t); 

    cout << "x: " << p.x(0) << " " << p.x(1) << " " <<  p.x(2) << endl;
    cout << "y: " <<  p.y(0) << " " << p.y(1) << " " <<  p.y(2) << endl;
    
    p.setxy(1, 5.0, 6.0);
//    p.setxy(7, 3.0, 6.0); // Exception: index is out of bound!

//    p.setxy(0, 5.0, 9.0); // Exception: duplicated x at different indexes!
    p.setxy(2, 5.0, 8.0); // no Exception: index is the same 

    cout << "After calling setter: " << endl;
    cout << "x: " << p.x(0) << " " << p.x(1) << " " << p.x(2) << endl;
    cout << "y: " << p.y(0) << " " << p.y(1) << " " << p.y(2) << endl;
    
    for(int i=0; i<11; ++i) {
       double x = i*0.5;
       cout << "table(" << x << ") = " << p(x) << endl;
    }

//    cout << "p(11.0) = " << p(11.0) << endl; // exception: x is out of range
    return 0;
}
